///////////////////////////////////////////////////////////////////////
//
//  File				:	global.h
//  Classes				:	-
//  Description			:	Some global definitions
//
//
//
//
//
////////////////////////////////////////////////////////////////////////


//
//
//
//
//
//
//		This header has to be included from every file
//
//
//
//
//
//
//
#ifndef GLOBAL_H
#define	GLOBAL_H

// #define	float	double
// In case you want to have double precision stuff

// Come constant definitions
// Math constants
#define	INFINITY							(float) 1e30
#define	EPSILON								(float) 1e-6


// The most famous number
#ifndef PI
#define	PI									(float) 3.141592653589793238462643383279502884197169399375105820974944592308
#define	DOUBLE_PI							3.141592653589793238462643383279502884197169399375105820974944592308
#endif

// Logic constants
#define	TRUE								1
#define	FALSE								0


// Misc Options and Attributes constants
#ifdef min
#undef min
#endif

#ifdef max
#undef max
#endif

#ifdef zero
#undef zero
#endif

#ifdef equal
#undef equal
#endif

#ifdef radians
#undef radians
#endif

#ifdef degrees
#undef degrees
#endif

#define			min(a,b)					(a < b ? a : b)
#define			max(a,b)					(a > b ? a : b)
#define			clamp(a,b,c)				(b < a ? a : (b > c ? c : b))
#define			zero(a)						(fabs(a) < EPSILON ? TRUE : FALSE)
#define			equal(a,b)					(zero(a-b))
#define			radians(a)					((float) (a*PI/(float) 180))
#define			degrees(a)					((float) (a*180/PI))

typedef union {
	int				integer;
	unsigned int	uinteger;
	float			real;
	void			*pointer;
	char			*string;
} T32;

#ifdef __INTEL_COMPILER
#define	USE_SSE
#else	// __INTEL_COMPILER
#ifdef WIN32

// Visual C does not support restrict pointers yet
#define restrict

#ifdef _DEBUG
//#ifdef _MEMMANAGE

// Register some junk for memory leak detection
//#define _CRTDBG_MAP_ALLOC
//#include <malloc.h>
//#include <stdlib.h>
//#include <crtdbg.h>


//#ifndef new

//#define MYDEBUG_NEW   new( _NORMAL_BLOCK, __FILE__, __LINE__)

//#define new MYDEBUG_NEW

//#endif	// new
//#endif	// MEMMANAGE
#endif	// _DEBUG
#else
#define restrict __restrict__
#endif	// WIN32
#endif	// __INTEL_COMPILER



#ifndef assert
#ifdef WIN32
#ifdef _DEBUG
#include <assert.h>
#endif // Debug
#endif // Win32
#endif
#endif

#ifndef assert
#define assert
#endif