///////////////////////////////////////////////////////////////////////
//
//  File				:	str.h
//  Classes				:	-
//  Description			:	string wrappers
//
//
//
//	Ver 11/28/2001
//
////////////////////////////////////////////////////////////////////////

#ifndef STR_H
#define STR_H

#include <string.h>
#include <malloc.h>


inline char	*scpy(char *d,const char *s) {
	return strcpy(d,s);
}

inline char	*scpy(char *d,const char *s,int l) {
	return strncpy(d,s,l);
}

inline char	*sdup(const char *s) {
	return strdup(s);
}

inline char	*sdup(const char *s,int b,int e) {
	char	*tmp	=	(char *) malloc(e-b+1);
	scpy(tmp,&s[b],e-b);
	tmp[e-b]	=	'\0';
	return tmp;
}

inline char *schr(const char *s,const char e) {
	return strchr(s,e);
}


inline char *srchr(const char *s,const char e) {
	return strrchr(s,e);
}

inline void	sfree(char *s) {
	free(s);
}

inline int		scmp(const char *s1,const char *s2) {
	return strcmp(s1,s2);
}

inline int		scmp(const char *s1,const char *s2,int l) {
	return strncmp(s1,s2,l);
}


inline int		slen(const char *s) {
	return strlen(s);
}

inline char		*scat(char *s,const char *d) {
	return strcat(s,d);
}

inline	void	srev(char *s) {
#ifdef WIN32
	strrev(s);
#else
	int	i,j;

	for (i=0,j=slen(s)-1;i < j;i++) {
		char	t	=	s[i];
		s[i]		=	s[j];
		s[j]		=	t;
	}
#endif
}

inline void		mcpy(void *d,void *s,int n) {
	memcpy(d,s,n);
}


#endif
