%option never-interactive
%option noyywrap 
%%
diffuse								return MESH_DIFFUSE;
specular							return MESH_SPECULAR;
texture								return MESH_TEXTURE;
color								return MESH_COLOR;

material							return MESH_MATERIAL;

vertices							return MESH_VERTICES;
triangles							return MESH_TRIANGLES;
materials							return MESH_MATERIALS;

scale								return MESH_SCALE;
rotate								return MESH_ROTATE;
translate							return MESH_TRANSLATE;

\(									return MESH_OPEN;
\)									return MESH_CLOSE;

\".*\"								{	scpy(yylval.string,&yytext[1]);	yylval.string[slen(yylval.string)-1] = '\0';	return MESH_TEXT;			}
[+-]?([0-9]+([eE][+-]?[0-9]+)?|([0-9]*\.[0-9]+)([eE][+-]?[0-9]+)?)	{	yylval.real = (float) atof(yytext);		return MESH_FLOAT;			}

\#.*								;
[\t ]*								;
\n									{ extern int lineNo; lineNo++; } ;

%%


