#ifndef MYSIMULATION_H
#define MYSIMULATION_H

#include "simulation.h"
#include "psystem.h"
#include "common/os.h"

const	unsigned	int		MATERIAL_TEXTUREMAPPED	=	1;


class	CMyGeometry : public CGeometry {
public:
	class CMyTriangle {									// Additional data per triangle
	public:
		float	uCoord[3];								// Texture coordinates
		float	vCoord[3];
		int		materialID;								// Index into the material table
	};

	class CMaterial {
	public:
						CMaterial() {
							materialFlags	=	0;
						}

						~CMaterial() {
						}

		unsigned int	textureID;
		vector			diffuse,specular,color;
		unsigned int	materialFlags;

		static	int		loadTexture(char *name);
	};

public:

	void		draw();
	void		prepare();

	int			numMaterials;
	CMaterial	*materials;
	CMyTriangle	*triangleDatas;
	int			listItem;
};

class CMySimulation : public CSimulation {
public:
	class CLight {
	public:
		vector		color;
		vector		dir;
		float		w;
		vector		ambient;
	};

public:
					CMySimulation();
	virtual			~CMySimulation();

	void			draw(float *toCamera,float *fromCamera,float tx,float ty,float tz,float dtime);
	void			geometry(CGeometry *g,float *R,float *P);
	void			step(float);

	void			addLight(CLight *);
	void			prepare();

	float			refreshRate;

	CLight			*lights;
	int				nLights,mLights;

	int				globalList;
};

extern	CMyGeometry		*parseGeometry(const char *);
extern	CMySimulation	*parseScene(const char *);

#endif
