// rigidDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rigid.h"
#include "rigidDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRigidDlg dialog

CRigidDlg::CRigidDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRigidDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRigidDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	graphics	=	NULL;
	sim			=	NULL;

}

CRigidDlg::~CRigidDlg() {
	if (graphics != NULL) {
		delete graphics;
	}

	if (sim != NULL) {
		delete sim;
	}
}

void CRigidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRigidDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRigidDlg, CDialog)
	//{{AFX_MSG_MAP(CRigidDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_OPENGLINFO, OnFileOpenglinfo)
	ON_COMMAND(ID_FILE_SAVEFRAMES, OnFileSaveframes)
	ON_COMMAND(ID_SIMULATION_GO, OnSimGo)
	ON_COMMAND(ID_SIMULATION_RESET, OnSimulationReset)
	ON_COMMAND(ID_SIMULATION_STOP, OnSimStop)
	ON_COMMAND(ID_MOUSE_ROTATE, OnRotate)
	ON_COMMAND(ID_SIM_STOP, OnSimStop)
	ON_COMMAND(ID_SIM_GO, OnSimGo)
	ON_COMMAND(ID_MOUSE_PAN, OnPan)
	ON_COMMAND(ID_MOUSE_ZOOM, OnZoom)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRigidDlg message handlers

BOOL CRigidDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// TODO: Add extra initialization here
	{
		CGraphics	gr;

		graphics	=	new COpenGL(this->m_hWnd,&gr);

		tx				=	(float) 0.0;
		ty				=	(float) 0.0;
		tz				=	(float) -13;

		identitym(toCamera);
		identitym(fromCamera);
		identitym(tmpToCamera);
		identitym(tmpFromCamera);

		/*
		rotatem(fromCamera,0,0,1,45);
		rotatem(toCamera,0,0,1,-45);

		{
			matrix	mtmp,mtmp2;

			rotatem(mtmp,1,0,0,45);
			mulmm(mtmp2,fromCamera,mtmp);
			movmm(fromCamera,mtmp2);

			rotatem(mtmp,1,0,0,-45);
			mulmm(mtmp2,mtmp,toCamera);
			movmm(toCamera,mtmp2);
		}
		*/

		

		{
			RECT	rgn;

			GetClientRect(&rgn);

			width	=	rgn.right - rgn.left;
			height	=	rgn.bottom - rgn.top;
		}

		graphics->makeCurrent();
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glFrustum(-0.1,0.1,-0.1,0.1,0.1,1000);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glTranslatef(tx,ty,tz);
		glMultMatrixf(toCamera);
		

		currentMouseState	=	MOUSE_ROTATING;

		sim					=	parseScene("..\\..\\projects\\data\\scene1.scn");
		simulationStatus	=	SIMULATION_STOPPED;
		dtime				=	0;

		SetWindowText("default simulation");
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRigidDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if (graphics != NULL) {
			refresh();
		}


		CDialog::OnPaint();
	}
}

void	CRigidDlg::refresh() {
	graphics->makeCurrent();

	glClearColor(0,0,0,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	if (sim != NULL) {
		glPushMatrix();
		sim->draw(toCamera,fromCamera,tx,ty,tz,dtime);
		glPopMatrix();
		//Run();
	} else {
	}

	graphics->swapBuffers();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRigidDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRigidDlg::OnFileExit() {
	// TODO: Add your command handler code here
}

/*
void CRigidDlg::OnFileOpen() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnFileOpenglinfo() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnFileSaveframes() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnSimulationGo() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnSimulationReset() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnSimulationStop() 
{
	// TODO: Add your command handler code here
	
}

void CRigidDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CRigidDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CRigidDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);
}
*/




void CRigidDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
		// TODO: Add your message handler code here and/or call default
	movmm(tmpFromCamera,fromCamera);
	movmm(tmpToCamera,toCamera);

	lastX	=	point.x;
	lastY	=	point.y;	

	
	CDialog::OnLButtonDown(nFlags, point);
}

void CRigidDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CRigidDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (nFlags & MK_LBUTTON) {
		switch(currentMouseState) {
		case MOUSE_ROTATING:
			if (graphics != NULL) {
				float	l;
				float	dx,dy;
				matrix	transformation;

				// Get the rotation axis
				dx	=	(float) (point.x - lastX);
				dy	=	(float) (point.y - lastY);
				l	=	(float) sqrt(dx*dx + dy*dy);
				dy	=	-dy;

				// Normalize the sucker
				dx	/=	l;
				dy	/=	l;

				// Construct the rotation matrix
				rotatem(transformation,-dy,dx,0,(float) (l*0.5));
				// Multiply it with the old matrix
				mulmm(toCamera,transformation,tmpToCamera);

				// Construct inverse the rotation matrix
				rotatem(transformation,dy,-dx,0,(float) (l*0.5));
				// Multiply it with the old matrix
				mulmm(fromCamera,tmpFromCamera,transformation);
				
				// Set the matrix
				graphics->makeCurrent();
				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();
				glTranslatef(tx,ty,tz);
				glMultMatrixf(toCamera);
			}
			break;
		case MOUSE_PANNING:
			if (graphics != NULL) {
				float	dx,dy;
				graphics->makeCurrent();

				
				dx	=	(float) (point.x - lastX)*tz;
				dy	=	(float) (point.y - lastY)*tz;

				dx	/=	-width;
				dy	/=	height;

				tx	+=	dx;
				ty	+=	dy;

				lastX	=	point.x;
				lastY	=	point.y;

				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();
				glTranslatef(tx,ty,tz);
				glMultMatrixf(toCamera);
			}
			break;
		case MOUSE_ZOOMING:
			if (graphics != NULL) {
				float	dx;
				graphics->makeCurrent();

				
				dx	=	(float) (point.x - lastX)*tz;

				dx	/=	-width;

				tz	+=	dx;

				lastX	=	point.x;
				lastY	=	point.y;

				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();
				glTranslatef(tx,ty,tz);
				glMultMatrixf(toCamera);
			}	break;
		default:
			break;
		}

		InvalidateRect(NULL,FALSE);
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CRigidDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CMenu		popup;

	ClientToScreen(&point);

	popup.CreatePopupMenu();
	switch(currentMouseState) {
	case MOUSE_ROTATING:
	popup.AppendMenu(MF_ENABLED | MF_CHECKED | MF_STRING, ID_MOUSE_ROTATE, "Rotate");
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_PAN, "Pan");
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_ZOOM, "Zoom");
	break;
	case MOUSE_PANNING:
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_ROTATE, "Rotate");
	popup.AppendMenu(MF_ENABLED | MF_CHECKED | MF_STRING, ID_MOUSE_PAN, "Pan");
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_ZOOM, "Zoom");
	break;
	case MOUSE_ZOOMING:
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_ROTATE, "Rotate");
	popup.AppendMenu(MF_ENABLED | MF_STRING, ID_MOUSE_PAN, "Pan");
	popup.AppendMenu(MF_ENABLED | MF_STRING | MF_CHECKED, ID_MOUSE_ZOOM, "Zoom");
	break;
	}

	popup.AppendMenu(MF_ENABLED | MF_STRING | MF_SEPARATOR);

	if (simulationStatus == SIMULATION_PLAYING)
		popup.AppendMenu(MF_ENABLED | MF_STRING, ID_SIM_STOP, "Stop");
	else
		popup.AppendMenu(MF_ENABLED | MF_STRING, ID_SIM_GO, "Go");

	popup.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this, NULL);
	popup.DestroyMenu();

	
	CDialog::OnRButtonDown(nFlags, point);
}

void CRigidDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnRButtonUp(nFlags, point);
}

void CRigidDlg::OnRotate() {
	currentMouseState	=	MOUSE_ROTATING;	
}

void CRigidDlg::OnPan() {
	currentMouseState	=	MOUSE_PANNING;	
}

void CRigidDlg::OnZoom() {
	currentMouseState	=	MOUSE_ZOOMING;	
}

void CRigidDlg::OnSimStop() {
	simulationStatus		=	SIMULATION_STOPPED;
	KillTimer(ID_SIM_TIMER);
	dtime	=	0;
}

void CRigidDlg::OnSimGo() {
	if (sim != NULL) {
		simulationStatus		=	SIMULATION_PLAYING;
		SetTimer(ID_SIM_TIMER,(int) (sim->refreshRate*1000),NULL);
	}
}

void CRigidDlg::OnSize(UINT nType, int cx, int cy) 
{
	if (graphics != NULL) {
		graphics->makeCurrent();

		glViewport(0,0,cx,cy);

		width	=	cx;
		height	=	cy;
	}

	CDialog::OnSize(nType, cx, cy);	
}

void CRigidDlg::OnTimer(UINT nIDEvent) 
{
	if (sim != NULL) {
		dtime	=	((int) (sim->refreshRate*1000)) / (float) 1000;
		
		refresh();
	}

	CDialog::OnTimer(nIDEvent);
}

void CRigidDlg::OnFileOpen() {
	CFileDialog	openDlg(TRUE);

	if (openDlg.DoModal()) {
		CString	fileName	=	openDlg.GetPathName();

		if (fileName != "") {
			CMySimulation	*tsim	=	parseScene((LPCTSTR) fileName);

			if (tsim != NULL) {
				if (sim != NULL) {
					delete sim;
					dtime				=	0;
					if (simulationStatus == SIMULATION_PLAYING)
						OnSimStop();
				} else {
				}

				sim	=	tsim;
			}

			SetWindowText(fileName);

			InvalidateRect(NULL,FALSE);
		}
	} 
}

void CRigidDlg::OnSimulationReset() 
{
	if (sim != NULL) {
		sim->reset();
	}
}

void CRigidDlg::OnFileOpenglinfo() {
	if (graphics != NULL) {
		graphics->makeCurrent();
		{
			char	displayString[1024];

			sprintf(displayString,"Vendor: %s\nRenderer: %s\n",glGetString(GL_VENDOR),glGetString(GL_RENDERER));

			if (scmp((const char *) glGetString(GL_VENDOR),"Microsoft",slen("Microsoft")) == 0) {
				scat(displayString,"\n!!!Either you have a sucky graphics card,\nor I screwd up the drivers again!!!");
				scat(displayString,"\nPlaying some Quake usually helps to re-locate the correct drivers.\n(I'm serious)");
			}

			MessageBox(displayString,"OpenGL Info");
		}
	}
}

void CRigidDlg::OnFileSaveframes() {
}

void CRigidDlg::OnSimulationStop() {
	simulationStatus		=	SIMULATION_STOPPED;
	KillTimer(ID_SIM_TIMER);
	dtime	=	0;	
}

