// rigidDlg.h : header file
//

#if !defined(AFX_RIGIDDLG_H__8684C34D_30DB_4470_8907_4A7E52C94E4B__INCLUDED_)
#define AFX_RIGIDDLG_H__8684C34D_30DB_4470_8907_4A7E52C94E4B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include	"mySimulation.h"

#include	"common/graphics.h"
#include	"common/opengl.h"



/////////////////////////////////////////////////////////////////////////////
// CRbodyDlg dialog


typedef enum {
	MOUSE_ROTATING,
	MOUSE_PANNING,
	MOUSE_ZOOMING
} EMouseState;

typedef enum {
	SIMULATION_PLAYING,
	SIMULATION_STOPPED
} ESimulationStatus;


/////////////////////////////////////////////////////////////////////////////
// CRigidDlg dialog

class CRigidDlg : public CDialog
{
// Construction
public:
	CRigidDlg(CWnd* pParent = NULL);	// standard constructor
	~CRigidDlg();						// standard constructor

// Dialog Data
	//{{AFX_DATA(CRigidDlg)
	enum { IDD = IDD_RIGID_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRigidDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
	COpenGL				*graphics;
	CMySimulation		*sim;

	// GUI stuff
	matrix				toCamera,fromCamera;
	matrix				tmpToCamera,tmpFromCamera;

	EMouseState			currentMouseState;

	ESimulationStatus	simulationStatus;

	float				tx,ty,tz;
	int					lastX,lastY;
	float				lastZ;
	int					width,height;
	
	float				dtime;

	void				refresh();

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRigidDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg	void OnRotate();
	afx_msg	void OnSimStop();
	afx_msg	void OnSimGo();
	afx_msg	void OnPan();
	afx_msg void OnZoom();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileExit();
	afx_msg void OnFileOpen();
	afx_msg void OnFileOpenglinfo();
	afx_msg void OnFileSaveframes();
	afx_msg void OnSimulationGo();
	afx_msg void OnSimulationReset();
	afx_msg void OnSimulationStop();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RIGIDDLG_H__8684C34D_30DB_4470_8907_4A7E52C94E4B__INCLUDED_)
