%option never-interactive
%option noyywrap 
%%
rotate							return SCENE_ROTATE;
translate						return SCENE_TRANSLATE;
scale							return SCENE_SCALE;

light							return SCENE_LIGHT;
maxTimeStep						return SCENE_MAXTIMESTEP;
penetrationThreshold			return SCENE_PENETRATIONTHRESHOLD;
velocityDamper					return SCENE_VELOCITYDAMPER;
inertialDamper					return SCENE_INERTIALDAMPER;
friction						return SCENE_FRICTION;
restitution						return SCENE_RESTITUTION;
inpath							return SCENE_INPATH;
refreshRate						return SCENE_REFRESHRATE;

semitter						return SCENE_SEMITTER;
emitter							return SCENE_EMITTER;
forcer							return SCENE_FORCER;
psystem							return SCENE_PSYSTEM;
gravity							return SCENE_GRAVITY;
swirl							return SCENE_SWIRL;
sink							return SCENE_SINK;

body							return SCENE_BODY;
attach							return SCENE_ATTACH;
fixed							return SCENE_FIXED;
mass							return SCENE_MASS;
true							return SCENE_TRUE;
false							return SCENE_FALSE;
\(								return SCENE_OPEN;
\)								return SCENE_CLOSE;
\{								return SCENE_PUSH;
\}								return SCENE_POP;
\,								return SCENE_COMMA;
\;								return SCENE_SEMICOLON;
\=								return SCENE_EQUALS;

\"[^\"]*\"						{	scpy(yylval.string,&yytext[1]);	yylval.string[slen(yylval.string)-1] = '\0'; return SCENE_TEXT;			}
[+-]?([0-9]+([eE][+-]?[0-9]+)?|([0-9]*\.[0-9]+)([eE][+-]?[0-9]+)?)	{	yylval.real = (float) atof(yytext);		return SCENE_FLOAT;			}

\#.*								;
[\t ]*								;
\n									{ extern int sceneLineNo; sceneLineNo++; } ;
%%
